"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Action = void 0;

var _bzXml = _interopRequireDefault(require("bz-xml"));

var _utils = require("../utils");

var _constants = require("../constants");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var createAction = function createAction(actionDTO) {
  return {
    guid: (0, _utils.uuid)(),
    name: actionDTO.name,
    displayName: (0, _utils.toCamelCase)(actionDTO.name.replace('-', ' ')),
    description: actionDTO.description || actionDTO['description-en'] || actionDTO['description-es'],
    actiontype: _constants.CUSTOM,
    contenttype: '',
    resturl: '',
    httpoperation: _constants.HTTP_OPERATION,
    useauthentication: false,
    xsdinput: (0, _utils.toBase64)((0, _bzXml["default"])(actionDTO.inputs, _constants.INPUT)),
    xsdoutput: (0, _utils.toBase64)((0, _bzXml["default"])(actionDTO.outputs, _constants.OUTPUT))
  };
};

var Action = function Action(actionDTOs) {
  return actionDTOs.map(createAction);
};

exports.Action = Action;