#!/usr/bin/env node
"use strict";

var _path = require("path");

var _mkpath = require("mkpath");

var _core = require("./core");

var _utils = require("./utils");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

try {
  var config = require((0, _path.resolve)('./bz.config.js'));

  var definition = (0, _core.Definition)(_objectSpread(_objectSpread({
    id: (0, _utils.uuid)()
  }, config), {}, {
    auth: (0, _core.Auth)(config.auth),
    properties: (0, _core.Properties)(config.properties),
    actions: (0, _core.Action)(config.actions)
  }));
  (0, _mkpath.sync)("def", parseInt("0777", 8));

  _core.exporter.exportConnectorDefinition(definition);

  _core.exporter.exportConnectorActions(config.actions);

  console.info('Connector definition built.');
} catch (err) {
  console.error('An error ocurred while building your connector definition', err.message, err.stack);
}