"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.toCamelCase = exports.uuid = exports.toBase64 = void 0;

var toBase64 = function toBase64(source) {
  return new Buffer.from(source).toString('base64');
};
/**
 * Generates a UUID.
 * Native implementation taken from Bizagi's connector editor.
 */


exports.toBase64 = toBase64;

var uuid = function uuid() {
  var uuid = [];
  var rand = '0123456789abcdef';

  for (var n = 0; n < 36; n++) {
    var digit = rand.substr(Math.floor(16 * Math.random()), 1);
    uuid[n] = digit;
  }

  uuid[8] = uuid[13] = uuid[18] = uuid[23] = '-';
  uuid[14] = '4';
  uuid[19] = rand.substr(3 & uuid[19] | 8, 1);
  return uuid.join('');
};

exports.uuid = uuid;

var toCamelCase = function toCamelCase(source) {
  var indexes = [];

  for (var i = 0; i < source.length; i++) {
    if (source[i] === '-') {
      indexes.push(i);
    }
  }

  for (var _i = 0; _i < indexes.length; _i++) {
    source = source.replace('-', ' ');
  }

  var camelCased = source.replace(/(?:^\w|[A-Z]|\b\w)/g, function (letter, index) {
    return index == 0 ? letter.toLowerCase() : letter.toUpperCase();
  }).replace(/\s+/g, '');
  return camelCased;
};

exports.toCamelCase = toCamelCase;